How to help translate the app
=============================

There are 2 ways to translate the app:

**1. Standard way**

Take the original [strings.xml](/app/src/main/res/values/strings.xml) file, translate into your language and send the translated version to my email: odnovolov.artem@gmail.com. You may additionally find [the article about strings](https://developer.android.com/guide/topics/resources/string-resource) useful. As an example, I provide my translations:
* [strings.xml](/app/src/main/res/values-uk/strings.xml) (Ukrainian)
* [strings.xml](/app/src/main/res/values-ru/strings.xml) (Russian)


**2. Using the service Crowdin (recommended)**

Visit [the ForgetMeNot project page on Crowdin](https://crowdin.com/project/forgetmenot), select the language, select the file 'strings.xml'. You will come to edit mode. The advantage of this approach:
* user-friendly interface
* there are many strings accompanied with screenshots
* machine translation suggestions to help you complete the translation in one click
* you may translate not all at once
* provide up-to-date translations along with app evolution

Current state
-------------

I would like to express my deep gratitude to everyone (especially the people from [sekinfo.org](https://www.sekinfo.org)), who support the project by providing translation. You’re the best!

Language | Progress | Translators
---------|----------|------------
🏴󠁥󠁳󠁰󠁶󠁿 Basque | 99% | [soplatnik](https://crowdin.com/profile/soplatnik), [avtkal](https://crowdin.com/profile/avtkal)
🇫🇷 French | 99% | [Mr B](https://crowdin.com/profile/mrb7), [PhirosWolf](https://crowdin.com/profile/phiroswolf), [Sitavi](https://crowdin.com/profile/sitavi), [QuantiQia](https://crowdin.com/profile/quantiqia), [eiryelio](https://crowdin.com/profile/eiryelio), [Ryu1845](https://crowdin.com/profile/ryu1845)
🇩🇪 German | 51% | [avtkal](https://crowdin.com/profile/avtkal), [Zonrad_Kuse](https://crowdin.com/profile/zonrad_kuse), [statoquant](https://crowdin.com/profile/statoquant), [B14CK313](https://crowdin.com/profile/b14ck313), [trailingstock](https://crowdin.com/profile/trailingstock), [Yushin Washio](https://crowdin.com/profile/yuwash), [baschi29](https://crowdin.com/profile/baschi29), [Unwoven](https://crowdin.com/profile/unwovencrestless), [Nausika](https://crowdin.com/profile/nausika)
🇬🇷 Greek | 6% | [Vasilis Ioannidis](https://crowdin.com/profile/vioannidis)
🇮🇳 Hindi | 3% | [Swarnendu Maiti](https://crowdin.com/profile/swarnendu)
🇮🇩 Indonesian | 14% | [liimee](https://crowdin.com/profile/liimee)
🇵🇱 Polish | 4% | [F_I](https://crowdin.com/profile/f_i), [ggngnn](https://crowdin.com/profile/prubart)
🇧🇷 Portuguese, Brazilian | 31% | [Marcos Maciel](https://crowdin.com/profile/marcos_maciel_lima), [Lucas França](https://crowdin.com/profile/lucasnomad5g), [aleguiss](https://crowdin.com/profile/aleguiss)
🇷🇺 Russian | 100% | Odnovolov Artem
🇪🇸 Spanish | 99% | [sekinfo.org](https://www.sekinfo.org), [avtkal](https://crowdin.com/profile/avtkal), [Edwins0](https://crowdin.com/profile/edwins0), [Cod3Radar](https://crowdin.com/profile/cod3radar)
🇺🇦 Ukrainian | 100% | Odnovolov Artem
🇻🇳 Vietnamese | 57% | [bruhwut](https://crowdin.com/profile/bruhwut)

*P.S. English is not my native language. So feel free to point out my spelling mistakes.*